local vexalarm_spellprofiles_profile_load = ""
local vexalarm_spellprofiles_profile_delete = ""
local vexalarm_spellprofiles_profile_new = ""

local vexalarm_spellprofiles_receivedprofile_load = ""
local vexalarm_spellprofiles_receivedprofile_name = ""
local vexalarm_spellprofiles_receivedprofile_send = ""
local vexalarm_spellprofiles_receivedprofile_user = ""

function vexalarm.panel_spellprofiles()
	local receivedSpelllists = vexalarm_GetReceivedSpellProfileList()
	
	return {
		type = "group",
		args = {
			grpex = {
				name = vexalarm.Locale["profiles info grpname"],
				order=1, type = "group", dialogInline = true,
				args = {
					info1={name = vexalarm.Locale["spellprofiles info"], type="description", order=2, fontSize="medium"},
					space1={name= " ", type="description", order=10},
					},
				},
			frame_space1 = {name =" ", type = "description", order=2},
			grpadd = {
				name = vexalarm.Locale["profiles add grpname"],
				order=3, type ="group", dialogInline = true,
				args = {
					profile_new = {
						name = vexalarm.Locale["profiles add name"],
						desc = vexalarm.Locale["profiles add name desc"] ,
						order=1, type = "input", multiline = false, width = "double",
						validate = function (info, val)
							if vexalarm_profile_checkName(val) then return true
							else return "ERROR - "..val.." is not a valid name" end
							end,
						set = function(info,val) vexalarm_spellprofiles_profile_new = val end,
						get = function() return vexalarm_spellprofiles_profile_new end,
						},
					profile_new_add = {
						name = vexalarm.Locale["profiles add button"], width="half",
						order=2, type = "execute",
						func = function(info,val) vexalarm_spellprofile_add() end,
						},
					grpadddelete_allowed = {name =vexalarm.Locale["profiles add info"], type = "description", order=3, fontSize="medium"},
					},
				},
			frame_space2 = {name =" ", type = "description", order=4},
			grpdelete = {
				name = vexalarm.Locale["profiles delete grpname"],
				order=5, type ="group", dialogInline = true,
				args = {
					profile_delete = {
						name = vexalarm.Locale["profiles delete profile"],
						order=1, type = "select", style = "dropdown",
						values = vexalarm_spellprofiles["profilelist"],
						set = function(self,key) vexalarm_spellprofiles_profile_delete = key end,
						get = function() return vexalarm_spellprofiles_profile_delete end,
						},
					delete_exe = {
						name = vexalarm.Locale["profiles delete button"],
						order=2, type = "execute",
						func = function(info,val) vexalarm_spellprofile_delete() end,
						confirm = true,
						confirmText = vexalarm.Locale["profiles delete confirm"]
						},
					},
				},
			frame_space3 = {name =" ", type = "description", order=6},
			grpload = {
				name = vexalarm.Locale["profiles load grpname"],
				order=7, type ="group", dialogInline = true,
				args = {
					profile_load = {
						name = vexalarm.Locale["profiles load name"],
						order=1, type = "select", style = "dropdown",
						values = vexalarm_spellprofiles["profilelist"],
						set = function(self,key) vexalarm_spellprofiles_profile_load = key end,
						get = function() return vexalarm_spellprofiles_profile_load end,
						},
					load_exe = {
						name = vexalarm.Locale["spellprofiles load button"],
						order=2, type = "execute",
						func = function(info,val) vexalarm_spellprofile_load() vexalarm_initialize(true) end,
						},
					grpload_info = {name = vexalarm.Locale["spellprofiles load info"], type = "description", order=3, fontSize="medium"},
					},
				},
			frame_space4 = {name =" ", type = "description", order=8},
			grpSend = {
				name = vexalarm.Locale["spellprofiles send grpname"],
				order=9, type = "group", dialogInline = true,
				args = {
					send_profilename = {
						name = vexalarm.Locale["profiles load name"],
						order=1, type = "select", style = "dropdown",
						values = vexalarm_spellprofiles["profilelist"],
						set = function(self,key) vexalarm_spellprofiles_receivedprofile_send = key end,
						get = function() return vexalarm_spellprofiles_receivedprofile_send end,
						},
					send_target = {
						name = vexalarm.Locale["spellprofiles send to user"],
						order=2, type = "input", multiline = false, width = "double",
						set = function(info,val) vexalarm_spellprofiles_receivedprofile_user = val end,
						get = function() return vexalarm_spellprofiles_receivedprofile_user end,
						},
					send_exe = {
						name = vexalarm.Locale["spellprofiles send button"],
						order=3, type = "execute",
						func = function(info,val) vexalarm_SendSpellProfile() end,
						},
					},
				},
			frame_space5 = {name =" ", type = "description", order=10},
			grpSaveReceived = {
				name = vexalarm.Locale["spellprofiles save received grpname"],
				order=11, type = "group", dialogInline = true,
				args = {
					received_profile_load = {
						name = vexalarm.Locale["spellprofiles save received name"],
						order=1, type = "select", style = "dropdown",
						values = receivedSpelllists,
						set = function(self,key)
							vexalarm_spellprofiles_receivedprofile_load = key
							vexalarm_spellprofiles_receivedprofile_name = vexalarm_GetReceivedSpellProfileByKey(key)
							end,
						get = function() return vexalarm_spellprofiles_receivedprofile_load end,
						},
					received_profile_name = {
						name = vexalarm.Locale["spellprofiles save as"],
						desc = vexalarm.Locale["profiles add name desc"],
						order=2, type = "input", multiline = false, width = "double",
						validate = function (info, val)
							if vexalarm_profile_checkName(val) then return true
							else return "ERROR - "..val.." is not a valid name" end
							end,
						set = function(info,val) vexalarm_spellprofiles_receivedprofile_name = val end,
						get = function() return vexalarm_spellprofiles_receivedprofile_name end,
						},
					received_load_exe = {
						name = vexalarm.Locale["spellprofiles save button"],
						order=3, type = "execute",
						func = function(info,val) vexalarm_SaveIncomeSP() vexalarm_initialize(true) end,
						},
					received_grpload_info = {name = vexalarm.Locale["spellprofiles load info"], type = "description", order=3, fontSize="medium"},
					},
				},
			}
		}
end

function vexalarm_profile_checkName(val)
	local returnvalue = false
	local val_edited = string.gsub(val, "%a", "")
	val_edited = string.gsub(val_edited, "%d", "")
	val_edited = string.gsub(val_edited, " ", "")
	if val_edited == "" then returnvalue = true end
	if val == "" or val == "profilelist" then returnvalue = false end
	return returnvalue
end

function vexalarm_spellprofile_add()
	local key = vexalarm_spellprofiles_profile_new
	if key ~= "" then
		vexalarm_spellprofiles["profilelist"][key] = key
		vexalarm_spellprofiles[key] = vexalarm_CopyTable(vexalarm_spells)
		vexalarm_spellprofiles_profile_new = ""
	end
end

function vexalarm_spellprofile_delete(key)
	if key == nil then key = vexalarm_spellprofiles_profile_delete end
	if key ~= "" then
		vexalarm_spellprofiles["profilelist"][key] = nil
		vexalarm_spellprofiles[key] = nil
	end
	vexalarm_spellprofiles_profile_delete = ""
end

function vexalarm_spellprofile_load(key, slashcmd)
	if key == nil then
		key = vexalarm_spellprofiles_profile_load
	end
	if key ~= "" then
		if vexalarm_spellprofiles[key] == nil then print("|CFFFF7D0AVex Alarm|r - "..vexalarm.Locale["spellprofiles profile not found"])
		else
			vexalarm_spells = vexalarm_CopyTable(vexalarm_spellprofiles[key])
			vexalarm_loaddefaults(false)
			if slashcmd then print("|CFFFF7D0AVex Alarm|r - "..vexalarm.Locale["spellprofiles profile loaded 1"].." '"..key.."' "..vexalarm.Locale["spellprofiles profile loaded 2"]) end
		end
	end
	vexalarm_spellprofiles_profile_load = ""
end

-- thx to Lombra from WoWAce for this function
function vexalarm_CopyTable(settings)
	local copy = {}
	for k, v in pairs(settings) do
		if type(v) == "table" then  copy[k] = vexalarm_CopyTable(v)
		else						copy[k] = v end
	end
	return copy
end

function vexalarm_GetReceivedSpellProfileList()
	local returnvalue = {}
	for key,val in pairs(vexalarm.incomeSpellProfiles) do
		returnvalue[key] = val["timestamp"].." "..val["name"]
	end
	return returnvalue
end

function vexalarm_GetReceivedSpellProfileByKey(key)
	return vexalarm.incomeSpellProfiles[key]["name"]
end

function vexalarm_SaveIncomeSP()
	local key = vexalarm_spellprofiles_receivedprofile_load
	local name = vexalarm_spellprofiles_receivedprofile_name
	if vexalarm.incomeSpellProfiles[key]~= nil and vexalarm_spellprofiles_receivedprofile_name~="" then
		vexalarm_spellprofiles["profilelist"][name] = name
		vexalarm_spellprofiles[name] = vexalarm_CopyTable(vexalarm.incomeSpellProfiles[key]["data"])
		vexalarm_spellprofiles_receivedprofile_load = ""
		vexalarm_spellprofiles_receivedprofile_name = ""
	end
end

function vexalarm_SendSpellProfile()
	local spellprofile = vexalarm_spellprofiles_receivedprofile_send
	local user = vexalarm_spellprofiles_receivedprofile_user
	local packages = {}
	local timer = 0
	local currentpackage = 1
	
	vexalarm.SendSuccess = nil
	
	if vexalarm_spellprofiles[spellprofile]~= nil and user ~= "" then
		for key in pairs(vexalarm_spells_defaults) do
			if timer>=15 then
				currentpackage = currentpackage + 1
				timer = 0
			end
			timer = timer + 1
			
			if packages[currentpackage] == nil then
				packages[currentpackage] = ""
			end
			
			local text = key.."="
			for i=1,4 do
				local boolean = 0
				if vexalarm_spellprofiles[spellprofile][key] ~= nil then
					if vexalarm_spellprofiles[spellprofile][key][i] ~= nil then
						if vexalarm_spellprofiles[spellprofile][key][i] then
							boolean = 1
						end
					end
				end
				text = text..boolean
			end
			text = text.."="
			
			packages[currentpackage] = packages[currentpackage]..text..","
		end
	end
	local msgcount = #packages
	if msgcount > 0 then
		local timestamp = GetTime()
		for i=1,msgcount do
			local text = timestamp..";"..spellprofile..";"..i..";"..msgcount..";"..packages[i]..";"
			SendAddonMessage("VEXALARM_SP", text , "whisper" , user)
		end
		vexalarm.SentMsgs[tostring(timestamp)] = user
	end
end
































