function vexalarm.panel_spells(ID)
				
	local grps = {"",
				vexalarm.Locale["buffs"],
				vexalarm.Locale["selfbuffs"],
				vexalarm.Locale["grpbuffs"],
				vexalarm.Locale["instants"],
				vexalarm.Locale["instantsself"]}
	
	local classnames = {"DEATHKNIGHT", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR", ""}
	local classnames2 = {vexalarm.Locale["spells class dk"],
						vexalarm.Locale["spells class druid"],
						vexalarm.Locale["spells class hunter"],
						vexalarm.Locale["spells class mage"],
						vexalarm.Locale["spells class monk"],
						vexalarm.Locale["spells class pala"],
						vexalarm.Locale["spells class priest"],
						vexalarm.Locale["spells class rogue"],
						vexalarm.Locale["spells class shaman"],
						vexalarm.Locale["spells class wl"],
						vexalarm.Locale["spells class warrior"],
						vexalarm.Locale["spells class noclass"]}
	local rolenames = {vexalarm.Locale["spells role all"],
					vexalarm.Locale["spells role tank"],
					vexalarm.Locale["spells role heal"],
					vexalarm.Locale["spells role dd"],
					vexalarm.Locale["spells role notset"]}
	local orderStartvalue = 100
	local enable = {
			{"+", vexalarm.Locale["spells enable"], true},
			{"-", vexalarm.Locale["spells disable"], false}
			}
			
	local definitiontexts = {"",
			vexalarm.Locale["spells def buff"],
			vexalarm.Locale["spells def selfbuff"],
			vexalarm.Locale["spells def grpbuff"],
			vexalarm.Locale["spells def cast"],
			vexalarm.Locale["spells def selfcast"],
			}
	
	local options = {
		type = "group",
		args = {
			newspells = {name = vexalarm.Locale["spells contant to add"].."\n",
					type="description", fontSize="medium", order=1},
			definitiongrp = { name = "Definition", type="group", order= 2, dialogInline = true,
				args = { definitiontext = {name = definitiontexts[ID], type="description", fontSize="medium", order=1}, },
				}
			}
		}
	
	
	local optiongrp = {
		name = grps[ID], type = "group", dialogInline = true, args = {}, order=10,
		}
		
	local rank = 0
	local tablenumber = ID-1
	
	local spelltype = ""
	if 		tablenumber == 1 	then spelltype = "buff"
	elseif 	tablenumber == 2 	then spelltype = "selfbuff"
	elseif 	tablenumber == 3 	then spelltype = "grpbuff"
	elseif 	tablenumber == 4 	then spelltype = "instant"
	elseif 	tablenumber == 5 	then spelltype = "instantself" end
	
	-- +/- buttons
	local role = 0
	for i=1,5 do
		for j=1,2 do
			if i == 1 then 	role = nil		rank = (j*15)+1
			else 			role = i-1 		rank = i+(10*j) end
			optiongrp.args[tostring(ID).."_"..enable[j][2].."_role_"..tostring(i)] = vexalarm_spelloptions_button(rolenames[i], spelltype, enable[j], role, rank)
		end
	end
	
	options.args["buttons"] = optiongrp
	
	local spellrank = 0
	for i=1,#classnames do
		local spelllist = vexalarm_gen_alphabetical_spelllist(spelltype, classnames[i])
		local filledspells = false
		
		local spellclassgrp = { name = classnames2[i], type = "group", dialogInline = true, args = {}, order=10+i*2, }
		for j in ipairs(spelllist) do
			local key = spelllist[j][2]
			spellrank = spellrank + 1
			rank = (spellrank*10)+100
			options.args["space"..i] = {name = "\n", type="description", order=9+i*2}
			
			spellclassgrp.args[tostring(rank)] = vexalarm_spelloptions_description(key, rank)
			
			for z=1,4 do
				spellclassgrp.args[tostring(rank+z)] = vexalarm_spelloptions_toggle(rolenames[z+1], key, z, rank+z)
			end
					
			if j ~= #spelllist then spellclassgrp.args[tostring(rank+5)] = {name = "\n", type="description", order=rank+5} end	
			filledspells = true
		end
		if filledspells then options.args["spells"..i] = spellclassgrp end
	end
	

	return options
end

function vexalarm_gen_alphabetical_spelllist(spelltype, class)
	local returnvalue = {}
	-- get all spells of the category
	local place = 1
	for key, val in pairs(vexalarm_spells_defaults) do	
		if val[6] == spelltype and val[5] == class then
			if select(1, GetSpellInfo(tonumber(key))) ~= nil then
				returnvalue[place] = {select(1, GetSpellInfo(tonumber(key))), key}
				place = place + 1
			else
				vexalarm.wrongspells[key] = key
			end
		end
	end
	table.sort(returnvalue, function(a,b) return a[1]<b[1] end)
	return returnvalue
end

function vexalarm_spelloptions_button(rolestring, spelltype, enable, role, rank)
	local returnvalue = {
		name = enable[1].." "..rolestring,
		func = function(info,val) vexalarm_spelltoggle(spelltype, enable[3], role) end,
		order=rank, type = "execute",}
	if role~=4 then returnvalue.width="half" end
	if role == nil then returnvalue.desc = enable[2].." "..vexalarm.Locale["spells button"]
	else 				returnvalue.desc = enable[2].." "..vexalarm.Locale["spells button desc"].." "..rolestring end
	return returnvalue
end

function vexalarm_spelloptions_description(key, rank)
	local iconfile = select(3, GetSpellInfo(tonumber(key)))
	local spellname = select(1, GetSpellInfo(tonumber(key)))
	local temp = {fontSize="large", image = iconfile, type="description", order=rank}
	if 		key == "86669" then temp.name = vexalarm_colorize_class(spellname, key, "spell").." ("..vexalarm.Locale["spells extra 86669"]..")"
	elseif 	key == "86698" then temp.name = vexalarm_colorize_class(spellname, key, "spell").." ("..vexalarm.Locale["spells extra 86698"]..")"
	elseif 	key == "86659" then temp.name = vexalarm_colorize_class(spellname, key, "spell").." ("..vexalarm.Locale["spells extra 86659"]..")"
	elseif 	key == "77764" then temp.name = vexalarm_colorize_class(spellname, key, "spell").." ("..vexalarm.Locale["spells extra 77764"]..")"
	elseif 	key == "77761" then temp.name = vexalarm_colorize_class(spellname, key, "spell").." ("..vexalarm.Locale["spells extra 77761"]..")"
	else 						temp.name = vexalarm_colorize_class(spellname, key, "spell") end
	return temp
end

function vexalarm_spelloptions_toggle(rolestring, key, role, rank)	
	local returnvalue = {
						name = rolestring,
						order=rank, type = "toggle",
						desc = vexalarm.Locale["spells toggle desc"].." "..rolestring,
						set = function(info,val)
							if vexalarm_spells[key] == nil then vexalarm_spells[key]={} end
							vexalarm_spells[key][role]=val end,
						get = function()
							if vexalarm_spells[key]==nil then return false
							else return vexalarm_spells[key][role] end	end
						}
	
	if role ~= 4 then returnvalue.width="half" end
	return returnvalue
end

function vexalarm_spelltoggle(spelltype, val, role)
	if spelltype ~=nil then
		for tablekey,tableval in pairs(vexalarm_spells) do
			if tableval[6] == spelltype then
				if role ~=nil then vexalarm_spells[tablekey][role] = val
				else
					for i=1,4 do
						vexalarm_spells[tablekey][i] = val
					end
				end
			end
		end
	else
		vexalarm_spelltoggle("buff", val, role)
		vexalarm_spelltoggle("selfbuff", val, role)
		vexalarm_spelltoggle("grpbuff", val, role)
		vexalarm_spelltoggle("instant", val, role)
		vexalarm_spelltoggle("instantself", val, role)
	end
end

